//---------------------------------------------------------------------------

#ifndef NymOptionsDlgsH
#define NymOptionsDlgsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>

#include "NymFrames2.h"
//---------------------------------------------------------------------------

bool PACKAGE __fastcall OpenNymOptionsDialog(TForm *Owner, TNymsFrame2 *Frame,
    const AnsiString &Title);

class TNymOptionsDlg : public TForm
{
__published:	// IDE-managed Components
        TPageControl *PageControl;
        TButton *OkBtn;
        TButton *CancelBtn;
        TColorDialog *ColorDialog;
        TFontDialog *FontDialog;
        TTabSheet *GenTab;
        TButton *WorkColorBtn;
        TLabel *Label5;
        TPanel *Panel2;
        TPanel *WorkColor;
        TTabSheet *FontTab;
        TLabel *Label25;
        TLabel *Label26;
        TLabel *Label27;
        TLabel *Label28;
        TEdit *Name6;
        TEdit *Size6;
        TEdit *Style6;
        TPanel *Panel9;
        TPanel *Color6;
        TButton *EditFontBtn;
        TLabel *Label2;
        TLabel *Label7;
        TLabel *Label8;
        TLabel *Label9;
        TButton *WinFontBtn;
        TEdit *Name1;
        TEdit *Size1;
        TEdit *Style1;
        TPanel *Panel4;
        TPanel *Color1;
        TLabel *Label13;
        TLabel *Label10;
        TLabel *Label11;
        TLabel *Label12;
        TEdit *Name2;
        TEdit *Size2;
        TEdit *Style2;
        TPanel *Panel5;
        TPanel *Color2;
        TButton *DlgFontBtn;
        TTabSheet *NymTab;
        TGroupBox *GroupBox1;
        TCheckBox *OptAck;
        TCheckBox *OptSign;
        TCheckBox *OptDisable;
        TCheckBox *OptFixed;
        TCheckBox *OptFinger;
        TCheckBox *OptBcc;
        TCheckBox *OptCrypt;
        TLabel *Label1;
        TListBox *NymServers;
        TComboBox *LatentBox;
        TLabel *Label3;
        void __fastcall WinFontBtnClick(TObject *Sender);
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
        void __fastcall WorkColorBtnClick(TObject *Sender);
        void __fastcall DlgFontBtnClick(TObject *Sender);
        void __fastcall NymServersClick(TObject *Sender);
        void __fastcall EditFontBtnClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
        bool IniModified;
        AnsiString WinsFontStr, DlgsFontStr, EditFontStr, OrgNymServer, OrgOptions,
           OrgLatentTime;

        __fastcall virtual TNymOptionsDlg(TComponent* Owner);
        __fastcall virtual TNymOptionsDlg(TComponent* Owner, const AnsiString &Title);
        __fastcall virtual~TNymOptionsDlg();

        void __fastcall StrToFontBox(const AnsiString &FontStr, TEdit *Name,
           TEdit *Size, TEdit *Style, TPanel *Color);
        void __fastcall StrToFont(const AnsiString &FontStr, TFont *Font);
        AnsiString __fastcall FontToStr(TFont *Font);
};

//---------------------------------------------------------------------------
extern PACKAGE TNymOptionsDlg *NymOptionsDlg;
//---------------------------------------------------------------------------
#endif
