//---------------------------------------------------------------------------
#ifndef NymProfilesH
#define NymProfilesH

#include "FileMan2.h"
//---------------------------------------------------------------------------

class TNymProfile : public TStringList
{
private:
   AnsiString __fastcall GetNym();
   AnsiString __fastcall GetName();
   AnsiString __fastcall GetPGPKey();
   AnsiString __fastcall GetNymServer();
   AnsiString __fastcall GetUserId();
   AnsiString __fastcall GetNymIndexStr();
   AnsiString __fastcall GetPublicKeyID();
   AnsiString __fastcall GetSecretKeyID();
   AnsiString __fastcall GetNymCommands();
   bool __fastcall GetRetired();
public:
   __property AnsiString Nym =         { read = GetNym };
   __property AnsiString Name =        { read = GetName };
   __property AnsiString PGPKey =      { read = GetPGPKey };
   __property AnsiString NymServer =   { read = GetNymServer };
   __property AnsiString UserId =      { read = GetUserId };
   __property AnsiString NymIndexStr = { read = GetNymIndexStr };
   __property AnsiString PublicKeyID = { read = GetPublicKeyID };
   __property AnsiString SecretKeyID = { read = GetSecretKeyID };
   __property AnsiString NymCommands = { read = GetNymCommands };
   __property bool Retired =           { read = GetRetired };

   AnsiString  __fastcall GetOptions();
   void __fastcall GetPublicKey(TStrings *Key);
   void __fastcall GetPublicKeyNoKeyID(TStrings *Key);
   void __fastcall GetSecretKey(TStrings *Key);
   void __fastcall GetSecretKeyNoKeyID(TStrings *Key);
   int  __fastcall GetReplyBlocks(TStrings *Blocks);
   int  __fastcall GetHistory(TStrings *history);
   int  __fastcall GetHistory(int pos, TStrings *history);
   int  __fastcall CountHistories();
   void __fastcall GetReplay(TStrings *replay);
   void __fastcall GetNotes(TStrings *notes);
   void __fastcall GetLog(TStrings *log);
   void __fastcall Log(const AnsiString &msg);
   void __fastcall Retire();
};

/*class TNYMReplyBlock;

class TNYMReplyBlockLeg : public TStringList
{
public:
   int BlockIndex,LegIndex;
   TNYMReplyBlock *ReplyBlock;
   TStringList *rlist,*directives,*headers;
   __fastcall TNYMReplyBlockLeg();
   //bool __fastcall CheckInvalidRemailerName();
   //bool __fastcall CheckBadRecipientMatch();
   //bool __fastcall CheckInvalidDirectiveOrHeader();
   //bool __fastcall CheckInvalidAnonPostTo();
   //bool __fastcall CheckInvalidRecipient();
   //bool __fastcall IsValid();
};

class TNYMReplyBlock : public TStringList
{
public:
   int BlockIndex;
   TStringList *rlist,*directives,*headers;
   __fastcall TNYMReplyBlock();
   bool __fastcall GetLeg(int Idx, TNYMReplyBlockLeg *Leg);
   void __fastcall SetBlock(int BlockIdx, TStrings *Block);
   int  __fastcall LegCount();
 //bool __fastcall IsValid();
};

class TNYMReplyBlocks : public TStringList
{
public:
   TStringList *rlist,*directives,*headers;
   virtual __fastcall TNYMReplyBlocks();
   virtual __fastcall TNYMReplyBlocks(TStrings *Blocks);
   virtual __fastcall~TNYMReplyBlocks();
   bool __fastcall GetBlock(int Idx, TNYMReplyBlock *Block);
   void __fastcall SetBlocks(TStrings *Blocks);
   int  __fastcall BlockCount();
 //bool __fastcall AreValid();
};

int __fastcall TrimProfiles2MaxCount(TStrings *Profiles, int MaxBaks);

#define ACTIVE true
#define RETIRED false
#define NymMaxBaks 10

// error codes
#define NYMMAN_OK 1
#define NYMMAN_CANCEL 0
#define NYMMAN_NOSERVERKEY 			-100
#define NYMMAN_PROFILEISEMPTY 		-101
#define NYMMAN_REPLYBLOCKEMPTY 		-102

#define NYMMAN_BADPUBLICKEY 		-110
#define NYMMAN_BADSECRETKEY 		-111

#define NYMMAN_BADNYMSERVERNAME 	-130
#define NYMMAN_BADNYMCOMMAND 		-131
#define NYMMAN_BADNYMCOMMANDSTATE 	-132
#define NYMMAN_BADPGPKEYID 			-133
#define NYMMAN_NYMKEYNOTFOUND 		-134

#define NYMMAN_PUBLICKEYMISSING 	-140
#define NYMMAN_INCORRECTPUBLICKEY 	-141
#define NYMMAN_SECRETKEYMISSING 	-142
#define NYMMAN_INCORRECTSECRETKEY 	-143
*/
//---------------------------------------------------------------------------
#endif
