//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Global2.h"
#include "RBBrkWins.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TRBBrkWin *RBBrkWin = NULL;
//---------------------------------------------------------------------------

void __fastcall OpenBrokenChainsWindow(TForm *Owner)
{
   if (SecureModeMsg(Owner))
      return;

   if (dynamic_cast<TRBBrkWin*>(RBBrkWin) == NULL)
   {
      RBBrkWin = new TRBBrkWin(Owner);
      RBBrkWin->Show();
   }
   else
      RBBrkWin->BringToFront();
}
//---------------------------------------------------------------------------

__fastcall TRBBrkWin::TRBBrkWin(TComponent* Owner)
        : TForm(Owner)
{
   AnsiString spec = Global->DB->GetIni("brokenchainwin",
      IntToStr(((TForm*)Owner)->Left) + "," + IntToStr(((TForm*)Owner)->Top) + "," +
      IntToStr(Height) + "," + IntToStr(Width));

   Left = GetTok(0, spec, ',').ToInt();
   Top = GetTok(1,spec, ',').ToInt();
   Height = GetTok(2, spec, ',').ToInt();
   Width = GetTok(3, spec, ',').ToInt();

   Display->Clear();
   AnsiString rlisttxt = MixDir() + "rlist.txt";

   TStringList *rlist = new TStringList();
   if (FileExists(rlisttxt))
      rlist->LoadFromFile(rlisttxt);

   bool saving = false;
   for (int i = 0; i < rlist->Count; i++)
   {
      AnsiString line = rlist->Strings[i];

      if (line.Pos("Broken type-I remailer chains:") == 1)
      {
         saving = true;
         continue;
      }

      if (saving && line.Trim().IsEmpty())
         break;

      if (saving)
         Display->Lines->Add(line);
   }

   Display->SelStart = 0;
   Display->Perform(EM_SCROLLCARET, 0, 0);

   delete rlist;

   TColor color;
   LoadFonts(AppIni(), NymIni, color, Font, Display->Font, NULL);
   Display->Color = color;
}
//---------------------------------------------------------------------------

void __fastcall TRBBrkWin::FormClose(TObject *, TCloseAction &Action)
{
   Action = caFree;
}
//---------------------------------------------------------------------------

__fastcall TRBBrkWin::~TRBBrkWin()
{
   if (FileExists(AppDat()))
      Global->DB->PutIni("brokenchainwin", IntToStr(Left) + "," + IntToStr(Top) +
         "," + IntToStr(Height) + "," + IntToStr(Width));
   RBBrkWin = NULL;
}
//---------------------------------------------------------------------------

