//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Global2.h"
#include "RBEkxDlgs2.h"
#include "pgpsdk.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TRBEkxDlg2 *RBEkxDlg2;
//---------------------------------------------------------------------------

bool __fastcall OpenEncryptKeyDialog(TForm *Owner, AnsiString &KEYPassword,
   AnsiString &DESPassword, AnsiString &CASPassword,
   const AnsiString &Caps)
{
   RBEkxDlg2 = new TRBEkxDlg2(Owner);

   RBEkxDlg2->KEYPasswd = KEYPassword;
   RBEkxDlg2->DESPasswd = DESPassword;
   RBEkxDlg2->CASPasswd = CASPassword;
   RBEkxDlg2->Caps = Caps;

   RBEkxDlg2->ShowModal();

   bool ok = RBEkxDlg2->ModalResult == mrOk;
   if (ok)
   {
      KEYPassword = RBEkxDlg2->KEYPassword->Text;
      DESPassword = RBEkxDlg2->DESPassword->Text;
      CASPassword = RBEkxDlg2->CASPassword->Text;
   }

   delete RBEkxDlg2;
   return ok;
}
//---------------------------------------------------------------------------

__fastcall TRBEkxDlg2::TRBEkxDlg2(TComponent* Owner)
        : TForm(Owner)
{
   TColor color;
   LoadFonts(AppIni(), NymIni, color, Font, KEYPassword->Font, NULL);
   DESPassword->Font->Assign(KEYPassword);
   CASPassword->Font->Assign(DESPassword);
   KEYPassword->Color = color;
   DESPassword->Color = color;
   CASPassword->Color = color;
}
//---------------------------------------------------------------------------

bool __fastcall TRBEkxDlg2::HasCap(const AnsiString &Cap)
{
   return Caps.Pos(" " + Cap + " ") > 0;
}
//---------------------------------------------------------------------------

void __fastcall TRBEkxDlg2::FormShow(TObject *)
{
   if (!HasCap("ek"))
   {
      KEY->Checked = false;
      KEY->Enabled = false;
      KEYPassword->Color = clBtnFace;
      KEYPassword->Enabled = false;
      KEYPassword->Text = "";
   }

   if (!HasCap("ekx"))
   {
      DES->Checked = false;
      DES->Enabled = false;
      DESPassword->Color = clBtnFace;
      DESPassword->Enabled = false;
      DESPassword->Text = "";

      CAS->Checked = false;
      CAS->Enabled = false;
      CASPassword->Color = clBtnFace;
      CASPassword->Enabled = false;
      CASPassword->Text = "";
   }

   if (!KEYPasswd.IsEmpty())
   {
      KEYPassword->Text = KEYPasswd;
      KEYPassword->Color = clWindow;
      KEYPassword->Enabled = true;
      KEY->Checked = true;
   }
   if (!DESPasswd.IsEmpty())
   {
      DESPassword->Text = DESPasswd;
      DESPassword->Color = clWindow;
      DESPassword->Enabled = true;
      DES->Checked = true;
   }
   if (!CASPasswd.IsEmpty())
   {
      CASPassword->Text = CASPasswd;
      CASPassword->Color = clWindow;
      CASPassword->Enabled = true;
      CAS->Checked = true;
   }
}
//---------------------------------------------------------------------------

void __fastcall TRBEkxDlg2::FormCloseQuery(TObject *, bool &CanClose)
{
   if (ModalResult == mrOk)
   {
      if (KEY->Checked && KEYPassword->Text.IsEmpty())
      {
         MsgBox(this, "Encrypt-Key is checked. You must enter a password.",
            "Error", MB_OK);
         CanClose = false;
         return;
      }
      if (DES->Checked && DESPassword->Text.IsEmpty())
      {
         MsgBox(this, "Encrypt-3DES is checked. You must enter a password.",
            "Error", MB_OK);
         CanClose = false;
         return;
      }
      if (CAS->Checked && CASPassword->Text.IsEmpty())
      {
         MsgBox(this, "Encrypt-CAST is checked. You must enter a password.",
            "Error", MB_OK);
         CanClose = false;
         return;
      }
   }
}
//---------------------------------------------------------------------------

void __fastcall TRBEkxDlg2::KEYClick(TObject *)
{
   if (KEY->Checked)
   {
      KEYPassword->Text = KEYPasswd;
      if (KEYPassword->Text.IsEmpty())
         KEYPassword->Text = PGP->GetEncryptKey(ekLength);
      //KEYPassword->Color = clWindow;
      KEYPassword->Enabled = true;
   }
   else
   {
      KEYPasswd = KEYPassword->Text;
      KEYPassword->Clear();
      //KEYPassword->Color = clBtnFace;
      KEYPassword->Enabled = false;
   }
}
//---------------------------------------------------------------------------

void __fastcall TRBEkxDlg2::DESClick(TObject *)
{
   if (DES->Checked)
   {
      DESPassword->Text = DESPasswd;
      if (DESPassword->Text.IsEmpty())
         DESPassword->Text = PGP->GetEncryptKey(ekLength);
      //DESPassword->Color = clWindow;
      DESPassword->Enabled = true;
   }
   else
   {
      DESPasswd = DESPassword->Text;
      DESPassword->Clear();
      //DESPassword->Color = clBtnFace;
      DESPassword->Enabled = false;
   }
}
//---------------------------------------------------------------------------

void __fastcall TRBEkxDlg2::CASClick(TObject *)
{
   if (CAS->Checked)
   {
      CASPassword->Text = CASPasswd;
      if (CASPassword->Text.IsEmpty())
         CASPassword->Text = PGP->GetEncryptKey(ekLength);
      //CASPassword->Color = clWindow;
      CASPassword->Enabled = true;
   }
   else
   {
      CASPasswd = CASPassword->Text;
      CASPassword->Clear();
      //CASPassword->Color = clBtnFace;
      CASPassword->Enabled = false;
   }
}
//---------------------------------------------------------------------------

