//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
//#include <dateutils.hpp>

#include "global2.h"
#include "UpdateStatsDlgs.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TUpdateStatsDlg *UpdateStatsDlg;
//---------------------------------------------------------------------------

bool __fastcall UpdateStatsAndKeys(TForm *Owner)
{
   UpdateStatsDlg = new TUpdateStatsDlg(Owner);
   UpdateStatsDlg->ShowModal();
   bool ok = UpdateStatsDlg->ModalResult == mrOk;
   delete UpdateStatsDlg;
   return ok;
}
//---------------------------------------------------------------------------

bool __fastcall CheckNeedsRListUpdate()
{
   TDateTime currdatetime = Now();
   TDateTime listdatetime = FileDateTime(MixDir() + "rlist.txt");
   TDateTime ringdatetime = FileDateTime(MixDir() + "pubring.asc");

   if ((double)currdatetime - (double)listdatetime > 1 ||
       (double)currdatetime - (double)ringdatetime > 1)
   {
      switch (MsgBox(Application->MainForm,
         "Your mixmaster rlist.txt and/or pubring.asc are more than 1 day old!    \n"
         "May I update these pages before continuing?",
          MT_CONFIRM, MB_YESNOCANCEL))
      {
         case IDYES: UpdateStatsAndKeys(Application->MainForm);
         case IDCANCEL: return true;
         case IDNO: return false;
      }
   }

   return false;
}
//---------------------------------------------------------------------------

__fastcall TUpdateStatsDlg::TUpdateStatsDlg(TComponent* Owner)
        : TForm(Owner)
{
   TColor color;
   LoadFonts(AppIni(), NymIni, color, Font, NULL, NULL);
}
//---------------------------------------------------------------------------

void __fastcall TUpdateStatsDlg::FormCloseQuery(TObject *Sender,
      bool &CanClose)
{
   if (ModalResult == mrOk)
   {
      if (!FileExists(AppDir() + "QSstats.exe"))
      {
         MsgBox(this, "You must install 'QSstats' for this capability!",
            MT_INFO, MB_OK);
         CanClose = false;
         return;
      }

      AnsiString cmd = AppDir() + "qsstats.exe auto";

      if (PubringBox->Checked)
      {
         cmd += " pubring.asc";
      }

      if (RlistBox->Checked)
      {
         cmd += " rlist.txt";
      }

      Exec95(cmd);
   }
}
//---------------------------------------------------------------------------
